---
updatedAt: 2025-08-13T06:48:06.000Z
agentTools:
  projectIndex: https://docs.durianpay.id/llms.txt
---

# eWallet Notification

Durianpay triggers events whenever a status change occurs on your SNAP eWallet transaction. These events are sent to your configured webhook URL via HTTP POST.

- If your server does not respond with 200 OK, we retry delivery after 2, 5, 10, 90, and 210 minutes.
- Each request includes a signature header that must be verified before processing the payload.

# OpenAPI definition

```json
{
  "openapi": "3.0.0",
  "info": {
    "version": "1.0.0",
    "title": "durianpay-snap-api-payment-va-notif"
  },
  "servers": [
    {
      "url": "https://merchant-endpoint.com"
    }
  ],
  "paths": {
    "/v1.0/debit/notify": {
      "post": {
        "tags": [
          "default"
        ],
        "summary": "eWallet Notification",
        "description": "Durianpay triggers events whenever a status change occurs on your SNAP eWallet transaction. These events are sent to your configured webhook URL via HTTP POST.\n\n- If your server does not respond with 200 OK, we retry delivery after 2, 5, 10, 90, and 210 minutes.\n- Each request includes a signature header that must be verified before processing the payload.",
        "operationId": "ewallet-notif",
        "parameters": [
          {
            "name": "X-TIMESTAMP",
            "in": "header",
            "description": "(Required) Timestamp in ISO8601 format, Example: 2024-05-14T18:54:57+07:00",
            "schema": {
              "type": "string",
              "example": "<string>"
            },
            "examples": {
              "default": {
                "value": "<string>"
              }
            }
          },
          {
            "name": "X-SIGNATURE",
            "in": "header",
            "description": "(Required) Signature generated by encrypting HTTP method, relative path, minified request body, and timestamp",
            "schema": {
              "type": "string",
              "example": "<string>"
            },
            "examples": {
              "default": {
                "value": "<string>"
              }
            }
          },
          {
            "name": "X-PARTNER-ID",
            "in": "header",
            "description": "(Required) Unique ID for a partner given by Durianpay upon completing registration. Its value is same as the X-CLIENT-KEY",
            "schema": {
              "type": "string",
              "example": "<string>"
            },
            "examples": {
              "default": {
                "value": "<string>"
              }
            }
          },
          {
            "name": "X-EXTERNAL-ID",
            "in": "header",
            "description": "(Required) Unique messaging reference identifier generated by merchant and should be unique within the same day",
            "schema": {
              "type": "string",
              "example": "<string>"
            },
            "examples": {
              "default": {
                "value": "<string>"
              }
            }
          },
          {
            "name": "CHANNEL-ID",
            "in": "header",
            "description": "(Required) Device identification on which the API services is currently being accessed by the merchant. Possible value: 95221",
            "schema": {
              "type": "string",
              "example": "<string>"
            },
            "examples": {
              "default": {
                "value": "<string>"
              }
            }
          },
          {
            "name": "Content-Type",
            "in": "header",
            "schema": {
              "type": "string",
              "example": "application/json"
            },
            "examples": {
              "default": {
                "value": "application/json"
              }
            }
          },
          {
            "name": "Accept",
            "in": "header",
            "schema": {
              "type": "string",
              "example": "application/json"
            },
            "examples": {
              "default": {
                "value": "application/json"
              }
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "properties": {
                  "originalReferenceNo": {
                    "type": "string",
                    "description": "Durianpay’s unique transaction reference."
                  },
                  "latestTransactionStatus": {
                    "type": "string",
                    "description": "Latest transaction status code (e.g., “02”)."
                  },
                  "transactionStatusDesc": {
                    "type": "string",
                    "description": "Description of transaction status."
                  },
                  "createdTime": {
                    "type": "string",
                    "description": "Time the transaction was created."
                  },
                  "amount": {
                    "type": "object",
                    "properties": {
                      "value": {
                        "type": "string",
                        "description": "Transaction amount with 2 decimal places."
                      },
                      "currency": {
                        "type": "string",
                        "description": "Currency format in ISO 4217. Only \"IDR\" accepted."
                      }
                    },
                    "required": [
                      "value",
                      "currency"
                    ]
                  },
                  "additionalInfo": {
                    "type": "object",
                    "properties": {
                      "isLive": {
                        "type": "boolean",
                        "description": "Indicates if transaction is live or test."
                      },
                      "updatedTime": {
                        "type": "string",
                        "description": "Time the transaction was last updated."
                      },
                      "paidTime": {
                        "type": "string",
                        "description": "Time the transaction was paid (present only if completed)."
                      },
                      "failureReason": {
                        "type": "object",
                        "properties": {
                          "code": {
                            "type": "integer",
                            "description": "Error code (present only if failed)"
                          },
                          "message": {
                            "type": "string",
                            "description": "Error message (present only if failed)"
                          }
                        }
                      },
                      "customerInfo": {
                        "type": "object",
                        "properties": {
                          "customer_id": {
                            "type": "string",
                            "description": "Durianpay's internal customer reference ID."
                          },
                          "customer_ref_id": {
                            "type": "string",
                            "description": "Merchant's internal customer reference ID."
                          },
                          "given_name": {
                            "type": "string",
                            "description": "Customer name."
                          },
                          "email": {
                            "type": "string",
                            "description": "Customer email address."
                          },
                          "mobile": {
                            "type": "string",
                            "description": "Customer phone number."
                          }
                        }
                      }
                    },
                    "required": [
                      "isLive",
                      "updatedTime"
                    ]
                  }
                },
                "required": [
                  "originalReferenceNo",
                  "latestTransactionStatus",
                  "transactionStatusDesc",
                  "amount",
                  "additionalInfo"
                ],
                "x-examples": {
                  "Example 1": {
                    "originalReferenceNo": "pay_123",
                    "latestTransactionStatus": "00",
                    "transactionStatusDesc": "completed",
                    "amount": {
                      "value": "10000.00",
                      "currency": "IDR"
                    },
                    "additionalInfo": {
                      "isLive": false,
                      "createdTime": "2009-07-03T12:08:56+07:00",
                      "updatedTime": "2009-07-03T12:08:56+07:00",
                      "paidTime": "2009-07-03T12:08:56+07:00",
                      "failureReason": {
                        "code": 123,
                        "message": "failure"
                      },
                      "customerInfo": {
                        "customer_ref_id": "cust_001",
                        "given_name": "Jane Doe",
                        "email": "jane_doe@nomail.com",
                        "mobile": "085756073217"
                      }
                    }
                  }
                }
              },
              "examples": {
                "Transaction Completed": {
                  "value": {
                    "originalReferenceNo": "pay_123",
                    "latestTransactionStatus": "00",
                    "transactionStatusDesc": "completed",
                    "createdTime": "2009-07-03T12:08:56+07:00",
                    "amount": {
                      "value": "10000.00",
                      "currency": "IDR"
                    },
                    "additionalInfo": {
                      "isLive": false,
                      "updatedTime": "2009-07-03T12:08:56+07:00",
                      "paidTime": "2009-07-03T12:08:56+07:00",
                      "failureReason": {},
                      "customerInfo": {
                        "customer_ref_id": "cust_001",
                        "given_name": "Jane Doe",
                        "email": "jane_doe@nomail.com",
                        "mobile": "85722173217"
                      }
                    }
                  }
                },
                "Transaction Cancelled": {
                  "value": {
                    "originalReferenceNo": "pay_123",
                    "latestTransactionStatus": "05",
                    "transactionStatusDesc": "cancelled",
                    "createdTime": "2009-07-03T12:08:56+07:00",
                    "amount": {
                      "value": "10000.00",
                      "currency": "IDR"
                    },
                    "additionalInfo": {
                      "isLive": false,
                      "updatedTime": "2009-07-03T12:08:56+07:00",
                      "paidTime": "",
                      "failureReason": {},
                      "customerInfo": {
                        "customer_ref_id": "cust_001",
                        "given_name": "Jane Doe",
                        "email": "jane_doe@nomail.com",
                        "mobile": "85722173217"
                      }
                    }
                  }
                },
                "Transaction Failed": {
                  "value": {
                    "originalReferenceNo": "pay_123",
                    "latestTransactionStatus": "06",
                    "transactionStatusDesc": "failed",
                    "createdTime": "2009-07-03T12:08:56+07:00",
                    "amount": {
                      "value": "10000.00",
                      "currency": "IDR"
                    },
                    "additionalInfo": {
                      "isLive": false,
                      "updatedTime": "2009-07-03T12:08:56+07:00",
                      "paidTime": "",
                      "failureReason": {
                        "code": 123,
                        "message": "failure"
                      },
                      "customerInfo": {
                        "customer_ref_id": "cust_001",
                        "given_name": "Jane Doe",
                        "email": "jane_doe@nomail.com",
                        "mobile": "85722173217"
                      }
                    }
                  }
                },
                "Transaction Expired": {
                  "value": {
                    "originalReferenceNo": "pay_123",
                    "latestTransactionStatus": "08",
                    "transactionStatusDesc": "expired",
                    "createdTime": "2009-07-03T12:08:56+07:00",
                    "amount": {
                      "value": "10000.00",
                      "currency": "IDR"
                    },
                    "additionalInfo": {
                      "isLive": false,
                      "updatedTime": "2009-07-03T12:08:56+07:00",
                      "paidTime": "",
                      "failureReason": {},
                      "customerInfo": {
                        "customer_ref_id": "cust_001",
                        "given_name": "Jane Doe",
                        "email": "jane_doe@nomail.com",
                        "mobile": "85722173217"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "responseCode": {
                      "type": "string",
                      "description": "Response code indicating the result of the operation."
                    },
                    "responseMessage": {
                      "type": "string",
                      "description": "Message explaining the responseCode."
                    }
                  },
                  "x-examples": {
                    "Example 1": {
                      "responseCode": "2002500",
                      "responseMessage": "Success",
                      "virtualAccountData": {
                        "partnerServiceId": "088899",
                        "customerNo": "12345678901234567890",
                        "virtualAccountNo": " 08889912345678901234567890",
                        "virtualAccountName": "Jokul Doe",
                        "trxId": "va_ref_id",
                        "paymentRequestId": "pay_id"
                      }
                    }
                  }
                },
                "examples": {
                  "default": {
                    "value": {
                      "responseCode": "2005600",
                      "responseMessage": "Successful"
                    },
                    "summary": "default"
                  }
                }
              }
            },
            "headers": {
              "Content-Type": {
                "schema": {
                  "type": "string",
                  "example": "application/json"
                }
              }
            }
          }
        },
        "security": [
          {
            "apikeyAuth": []
          }
        ],
        "servers": [
          {
            "url": "https://merchant-endpoint.com"
          }
        ]
      }
    }
  },
  "components": {
    "securitySchemes": {
      "apikeyAuth": {
        "type": "http",
        "scheme": "apikey"
      }
    }
  },
  "security": [
    {
      "apikeyAuth": []
    }
  ]
}
```